import fs from "fs";
import path from "path";
import enjoySourceMap from "enjoy-source-map";
import ConvertSourceMap from "convert-source-map";
import parseHtml from "./parse-html";

const tpl = fs.readFileSync(path.join(__dirname, "tpl.js")).toString("utf8");

// 获取相对路径
function getRelativePath(file, root){
	return file.replace(root, "").replace(/\.(js|html|css)$/, "");
}

export default function loader(code){
	// 只在enjoy项目有效
	if(!this.customerInfo.isEnjoyProject){
		return code;
	}

	var callback = this.async();

	var map;
	if(ConvertSourceMap.commentRegex.test(code)){
		map = ConvertSourceMap.fromComment(code).toObject();
		// 如果是无效sourcemap，则移除掉
		if(!map.mappings || map.mappings === "AAAA"){
			code = ConvertSourceMap.removeComments(code);
		}
	}else{
		map = {
			sources: [this.file]
		};
	}

	parseHtml(
		code,
		map.sources[0] || this.file,
		this.params.elementFactoryName,
		this.params.platform,
		(result, components) => {
			var code = enjoySourceMap.overWriteTlp(tpl, {
				supportModName: "enjoy-" + (this.params.platform === "h5" ? "web" : this.params.platform) + "-support-elong",
				content: result.code,
				path: getRelativePath(this.file, this.packagePath),
				components: components,
				elementFactory: this.params.elementFactoryName
			});

			callback(code);
	});
}

loader.$name = "enjoy-web-html";